#include <iostream>
#include <fstream>

#include <stdlib.h>

#include "thread.h"
#include "controller.h"
#include "plugin.h"
#include "parameters.h"

#include "hdrshop.h"

const char *GetPluginDescription(void)
{
    return "Simple photographic tone mapping operator.  Does not gamma correct output!";
}

const char *GetPluginName(void)
{
    return "stm_photographic";
}

void GetModuleList(std::list<std::string> &modules)
{
    modules.push_back("pfmloader");
    modules.push_back("pfmsaver");
    modules.push_back("photographic");
}

void SetupPluginModules(control::Controller *stm,
                        std::vector<ParamDef> &parameters,
                        int &output_id)
{
    // First install processors.
    stm->AddActor(1, "photographic");
    
    // Now set up exported parameter list.

    parameters.push_back(ParamDef(1, std::string("key")));
    parameters.push_back(ParamDef(1, std::string("samples")));

    // Specify our output.
    output_id = 1;
}

void SetupPluginLinks(control::Controller *stm)
{
    // Now hook them up.
    stm->AddLink(1, 0, 0);
}
