#include <iostream>
#include <fstream>

#include <stdlib.h>

#include "thread.h"
#include "controller.h"
#include "plugin.h"
#include "parameters.h"

#include "hdrshop.h"

const char *GetPluginDescription(void)
{
    return "Star filter.  David Beynon 2011";
}

const char *GetPluginName(void)
{
    return "stm_star";
}

void GetModuleList(std::list<std::string> &modules)
{
    modules.push_back("pfmloader");
    modules.push_back("pfmsaver");
    modules.push_back("rays");
    modules.push_back("convolve_mono");
}

void SetupPluginModules(control::Controller *stm,
                        std::vector<ParamDef> &parameters,
                        int &output_id)
{
    // First install processors.
    stm->AddActor(1, "rays");
    stm->AddActor(2, "convolve_mono");
    
    // Now set up exported parameter list.

    parameters.push_back(ParamDef(1, std::string("number of rays")));
    parameters.push_back(ParamDef(1, std::string("angle")));
    parameters.push_back(ParamDef(1, std::string("unscattered")));
    parameters.push_back(ParamDef(1, std::string("half life")));
    parameters.push_back(ParamDef(1, std::string("minimum")));

    // Specify our output.
    output_id = 2;
}

void SetupPluginLinks(control::Controller *stm)
{
    // Now hook them up.
    stm->AddLink(2, 0, 0);
    stm->AddLink(2, 1, 1);
}
