#include "Config.h"

static QtGuiConfig *s_instance(NULL);

QtGuiConfig *
QtGuiConfig::GetInstance(void)
{

    if(!s_instance)
    {
        s_instance = new QtGuiConfig();
    }
    return s_instance;
}


// Gamma updated.
class ScreenGammaMessage : public SimpleObserverMessage
{
public:
    ScreenGammaMessage(const SimpleObservable *observable, float gamma)
        : SimpleObserverMessage(observable)
        , m_gamma(gamma)
    {
    }

    virtual ~ScreenGammaMessage()
    {
    }

    virtual void Deliver(SimpleObserver *observer) const
    {
        QtGuiConfigObserver *p = dynamic_cast<QtGuiConfigObserver*>(observer);

        if(p)
        {
            p->OnSetScreenGamma(m_gamma);
        }
    }

    virtual SimpleObserverMessage *Clone(void) const
    {
        return new ScreenGammaMessage(GetObservable(), m_gamma);
    }

private:
   float m_gamma;
};

void
QtGuiConfig::SetScreenGamma(float gamma)
{
    m_screenGamma = gamma;
    SimpleObserverMessage *msg = new ScreenGammaMessage(this, gamma);
    SendMessage(msg);
}

