#include "StmConfigDialog.h"

StmConfigDialog::StmConfigDialog(QWidget *parent)
    : QDialog(parent)
    , m_layout(this)
    , m_screenGamma(this)
    , m_screenGammaLabel(this)
{
    QtGuiConfig *cfg = QtGuiConfig::GetInstance();

    setWindowTitle("Configuration");

    // Label.
    m_screenGammaLabel.setText("Display Gamma");

    // Ranges.
    m_screenGamma.setMinimum(0.25);
    m_screenGamma.setMaximum(4);
    m_screenGamma.setSingleStep(0.1);

    // Values
    if(cfg)
    {
        m_screenGamma.setValue(cfg->GetScreenGamma());
    }
    // Layout

    m_layout.addWidget(&m_screenGammaLabel, 0, 0);
    m_layout.addWidget(&m_screenGamma, 0, 1);

    // Connections.
    connect(&m_screenGamma, SIGNAL(valueChanged(double)), SLOT(gammaChanged(double)));
}

void
StmConfigDialog::gammaChanged(double gamma)
{
    QtGuiConfig::GetInstance()->SetScreenGamma(gamma);
}

