#ifndef __STM_MAIN_VIEW_H__
#define __STM_MAIN_VIEW_H__

#include <vector>


#include <QWidget>
#include <QMenuBar>
#include <QMenu>
#include <QAction>

class StmWrapper;
class StmConfigDialog;
class StmView;

class QGridLayout;

class StmMainWindow : public QWidget
{
    Q_OBJECT

public:
    StmMainWindow(QWidget *parent, 
                const std::string &path,
                const std::list<std::string> &modules);

    virtual ~StmMainWindow();

private slots:
    // menu slots
    void loadImage(void);
    void changeOptions(void);

    // STM message slots
    void onImageLoaded(int);
    void onImageData(int, void *);
private:
    // document
    StmWrapper *m_wrapper;

    // view
    StmView *m_view;

    // pop up dialogs
    StmConfigDialog *m_optionsDialog;

    // layout
    QGridLayout *m_layout;

    // menus
    QMenuBar *m_menuBar;
    QMenu    *m_fileMenu;
    QMenu    *m_toolsMenu;

    // file menu actions
    QAction  *m_loadImage;
    QAction  *m_loadProcess;
    QAction  *m_saveProcess;

    // tool menu actions
    QAction *m_changeOptions;
};

#endif

