#ifndef __STM_WRAPPER_H__
#define __STM_WRAPPER_H__

#include <QThread>

namespace control
{
    class Controller;
}

class StmWrapper : public QThread
{
    Q_OBJECT
public:
    StmWrapper(const std::string &modulePath, const std::list<std::string> &modules);
    virtual ~StmWrapper();

    // TODO: Hide all this shit.
    control::Controller *GetController(void) const
    {
        return m_controller;
    }

    virtual void run();
signals:
    void imageData(int, void *);
    void imageLoaded(int);

    void progress(int, float);
    void parameters(int, void *);
    void processorAdded(int, const char *);
    void processorRemoved(int);
    void processor(int, void *);
    void terminate(void);
private:
    control::Controller *m_controller;
};

#endif 

