#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <fstream>

#include "utils.h"
#include "modules.h"
#include "processor.h"
#include "parameters.h"

#include <vector>

#include <QApplication>
#include <QWidget>

// Layout the doalog
#include <QGridLayout>

#include "StmProcessorDialog.h"
#include "StmConfigDialog.h"
#include "StmView.h"
#include "StmMainWindow.h"

int main(int argc, char **argv)
{
    std::string path;
    std::list<std::string> modules;

    {
        char *p = getenv("STM_MODULE_PATH");
        if(p)
        {
            path = p;
        }
    }

    // Get module list
    {
        std::string modfile = path + "/modules";

        std::ifstream str(modfile.c_str(), std::ifstream::in);

        if(str.is_open())
        {
            while(!str.eof())
            {
                std::string module;
                str >> module;
                if(module.length())
                {
                    std::cerr << "Identified module \"" << module << "\"."
                              << std::endl;
                    modules.push_back(module);
                }
            }
        }
    }

    if(modules.size() == 0)
    {
        std::cerr << "No modules found.  "
                  << "Check STM_MODULE_PATH environment variable."
                  << std::endl;
    }
    else
    {
        QApplication app(argc, argv);

        StmMainWindow *view = new StmMainWindow(NULL, path, modules);
        view->show();
        app.exec();
        delete view;
    }

    return 0;
}
