#ifndef __GENERATOR_H__
#define __GENERATOR_H__

#include <stdint.h>
#include <stdlib.h>
#include "processor.h"

namespace generators {

/*!
 *  Base class for generator classes.  These generate images with no need for
 *  an input image.  The primary consumer of these is currently the convolution
 *  processor.
 */
class Generator : public spectral::Processor
{
public:
    Generator()
    : Processor()
    {}
    virtual ~Generator() 
    {}

protected:
    /*!
     * Draw an anti aliased line
     */
    void DrawLine(spectral::Image *image,
                  void *data,
                  float x1, 
                  float y1, 
                  float x2, 
                  float y2, 
                  bool(*draw_pixel)(spectral::Image *, void *, int, int, float, float));
};

}

#endif
