#include <iostream>
#include "loader.h"
#include "saver.h"
#include "modules.h"
#include "file.h"

namespace spectral {

// windows porting crap
#ifdef LoadImage
#undef LoadImage
#endif

Image *SpLoadImage(Modules &modules, const std::string &name)
{
    Image *result = NULL;

    std::string fn = name;
    size_t pt;
    pt = fn.find_last_of('.', fn.npos);

    if(pt != fn.npos)
    {
        pt++;
        std::string ext = fn.substr(pt);

        if(fn.length() && ext.length())
        {
            std::map<std::string, std::string> loaders;
            modules.GetLoaders(loaders);
            
            std::map<std::string, std::string>::iterator i = 
                loaders.find(ext);

            if(i != loaders.end())
            {
                std::string module = i->second;
                Loader *loader= (Loader*)modules.CreateObject(module);

                if(loader)
                {
                    result = loader->LoadImage(fn);
                    delete loader;
                }
                else
                {
                    std::cerr << "Failed to create " << ext 
                              << " loader" << std::endl;
                }
            }
            else
            {
                std::cerr << "Failed to find " << ext 
                          << " loader" << std::endl;
            }
            
        }
    }
    return result;
}
void SpSaveImage(Modules &modules, Image *image, const std::string &name)
{
    std::string fn = name;
    size_t pt;
    pt = fn.find_last_of('.', fn.npos);
 
    if(pt != fn.npos)
    {
        pt++;
        std::string ext = fn.substr(pt);

        if(fn.length() && ext.length())
        {
            std::map<std::string, std::string> savers;
            modules.GetSavers(savers);
            
            std::map<std::string, std::string>::iterator i = 
                savers.find(ext);

            if(i != savers.end())
            {
                std::string module = i->second;
                Saver *saver= (Saver*)modules.CreateObject(module);

                if(saver)
                {
                    saver->SaveImage(image, fn);
                    delete saver;
                }
            }
            
        }
    }
}

}
