#include <stdio.h>

#include "utils.h"
#include "image.h"
#include "parameters.h"
#include "processor.h"
#include "controller.h"

#define MAX_THREADS 16

namespace spectral
{

Processor::Processor()
    : m_processThread(NULL)
{
}

Processor::~Processor()
{
}

void
Processor::Progress(float progress)
{
    if(m_processThread)
    {
        m_processThread->Progress(progress);
    }
}

Parameters *
Processor::GetParameters(void) const
{
    Parameters *result(NULL);

    result = new Parameters;

    if(result)
    {
        GetParameters(result);
    }

    return result;
}

// Virtuals

void
Processor::ClearImage(uint32_t)
{
}

}
