#ifndef __TIFF_LOADER_H__
#define __TIFF_LOADER_H__

#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <tiffio.h>

#include "loader.h"
#include "utils.h"

class TiffLoader : public spectral::Loader
{
public:
    TiffLoader()
    {
    }
    virtual ~TiffLoader()
    {
    }

    virtual spectral::Image *LoadImage(const std::string &);

private:
    bool tiff_get_size(TIFF *t, uint32_t *width, uint32_t *height);
    bool tiff_get_stonits(TIFF *t, double &stonits);
    bool tiff_get_whitepoint(TIFF *t, float *wp);
    bool tiff_get_primaries(TIFF *t, float *r, float *g, float *b);
    bool tiff_read_image_pixels(TIFF *t, spectral::Image *image);
    bool tiff_read_ieee_rgb(TIFF *t, uint32_t width, uint32_t height, float *buf);
    bool tiff_read_logluv(TIFF *t, uint32_t width, uint32_t height, float *buf);

    void buf_transform(Matrix33 matrix, size_t size, float *buf);
};

#endif
