#ifndef __CROPIMAGE_H__
#define __CROPIMAGE_H__

#include <stdint.h>
#include "processor.h"

namespace cropimage {

class CropImage : public spectral::Processor
{
public:
    CropImage();
    virtual ~CropImage();

protected:

    // Get slots & output type.  Returns output colour space.
    // pairs are <slot id, colour space>
    virtual uint32_t GetInterface(
        std::list<std::pair<uint32_t, uint32_t> > &mandatory,
        std::list<std::pair<uint32_t, uint32_t> > &optional) const;

    // Attempt to set an image in a slot.
    virtual bool SetImage(uint32_t type, const spectral::Image *img);

    // Apply parameters to a processor.
    virtual void SetParameters(const spectral::Parameters *);

    // Process images.
    virtual spectral::Image *Process(void);

    // Clear the image in a slot.
    virtual void ClearImage(uint32_t type);

protected:

    // Populate a spectral::Parameters object.
    virtual void GetParameters(spectral::Parameters *) const;

private:
    const spectral::Image *m_picture;

    int32_t m_x1, m_y1, m_x2, m_y2;
};

}

#endif
