#ifndef __FLIC_H__
#define __FLIC_H__

#include <stdint.h>
#include "image.h"
#include "field.h"

namespace spectral {

class Flic : public Field
{
public:
    Flic();
    virtual ~Flic();

protected:

    // Get slots & output type.  Returns output colour space.
    // pairs are <slot id, colour space>

    // Apply parameters to a processor.
    virtual void SetParameters(const Parameters *);

    // Process images.
    virtual Image *Process(void);

protected:

    // Populate a Parameters object.
    virtual void GetParameters(Parameters *) const;

    float m_threshold;
private:
};

}

#endif
