#ifndef __BILATERAL_H__
#define __BILATERAL_H__
#include <stdint.h>
#include "image.h"

#define USE_256_BINS

#if(defined(USE_8_BINS))
#define NUM_BINS 8
#define BIN_SIZE 32
#elif(defined(USE_32_BINS))
#define NUM_BINS 32
#define BIN_SIZE 8
#elif(defined(USE_64_BINS))
#define NUM_BINS 64
#define BIN_SIZE 4
#elif(defined(USE_128_BINS))
#define NUM_BINS 128
#define BIN_SIZE 2
#elif(defined(USE_256_BINS))
#define NUM_BINS 265
#define BIN_SIZE 1
#endif

spectral::Image *
bilateral_filter(uint32_t radius, 
                 uint32_t threshold, 
                 uint32_t tile_size, 
                 bool use_linear, 
                 const spectral::Image *image);

#endif
